/*
 * Copyright (C) 2006 Apple Computer, Inc.  All rights reserved.
 * Copyright (C) Research In Motion Limited 2009-2010. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#pragma once

#include "PlatformString.h"
#include <wtf/Forward.h>
#include <wtf/OwnPtr.h>
#include <wtf/Ref.h>
#include <wtf/RefCounted.h>
#include <wtf/Vector.h>

#if USE(CF)
#include <wtf/RetainPtr.h>
#endif

#if PLATFORM(MAC) || (PLATFORM(QT) && USE(QTKIT))
OBJC_CLASS NSData;
#endif

namespace WebCore {
    
class SharedBuffer : public RefCounted<SharedBuffer> {
public:
    static ALWAYS_INLINE Ref<SharedBuffer> create() { return adoptRef(*new SharedBuffer); }
    static ALWAYS_INLINE Ref<SharedBuffer> create(size_t size) { return adoptRef(*new SharedBuffer(size)); }
    static ALWAYS_INLINE Ref<SharedBuffer> create(const char* c, int i) { return adoptRef(*new SharedBuffer(c, i)); }
    static ALWAYS_INLINE Ref<SharedBuffer> create(const unsigned char* c, int i) { return adoptRef(*new SharedBuffer(c, i)); }

    static PassRefPtr<SharedBuffer> createWithContentsOfFile(const String& filePath);

    static Ref<SharedBuffer> adoptVector(Vector<char>& vector);
    
    ALWAYS_INLINE ~SharedBuffer() = default;
    
#if PLATFORM(MAC) || (PLATFORM(QT) && USE(QTKIT))
    NSData *createNSData();
    static PassRefPtr<SharedBuffer> wrapNSData(NSData *data);
#endif
#if USE(CF)
    CFDataRef createCFData();
    static PassRefPtr<SharedBuffer> wrapCFData(CFDataRef);
#endif

    // Calling this function will force internal segmented buffers
    // to be merged into a flat buffer. Use getSomeData() whenever possible
    // for better performance.
    ALWAYS_INLINE const char* data() const { return m_buffer.data(); }

    ALWAYS_INLINE unsigned size() const { return m_buffer.size(); }

    ALWAYS_INLINE char* releaseBuffer() { return m_buffer.releaseBuffer(); }

    ALWAYS_INLINE bool isEmpty() const { return !size(); }

    ALWAYS_INLINE void swap(Vector<char>& vector)
    {
    	m_buffer.swap(vector);
    }

    void setExpectedLength(int);

    void append(SharedBuffer*);
    void append(const char*, unsigned);
    void append(const Vector<char>&);

    bool tryAppend(SharedBuffer*);
    bool tryAppend(const char*, unsigned);
    bool tryAppend(const Vector<char>&);

    void clear();
    const char* platformData() const;
    unsigned platformDataSize() const;

#if HAVE(NETWORK_CFDATA_ARRAY_CALLBACK)
    void append(CFDataRef);
#endif

    PassRefPtr<SharedBuffer> copy() const;
    
    // Return the number of consecutive bytes after "position". "data"
    // points to the first byte.
    // Return 0 when no more data left.
    // When extracting all data with getSomeData(), the caller should
    // repeat calling it until it returns 0.
    // Usage:
    //      const char* segment;
    //      unsigned pos = 0;
    //      while (unsigned length = sharedBuffer->getSomeData(segment, pos)) {
    //          // Use the data. for example: decoder->decode(segment, length);
    //          pos += length;
    //      }
    unsigned getSomeData(const char*& data, unsigned position = 0) const;

    bool tryReplaceContentsWithPlatformBuffer(SharedBuffer&);
    bool hasPlatformData() const;

    struct DataBuffer : public ThreadSafeRefCounted<DataBuffer> {
        Vector<char> data;
    };

private:
    SharedBuffer();
    explicit SharedBuffer(size_t);
    SharedBuffer(const char*, int);
    SharedBuffer(const unsigned char*, int);
    
    void clearPlatformData();
    void maybeTransferPlatformData();
    
    mutable Vector<char> m_buffer;
};

PassRefPtr<SharedBuffer> utf8Buffer(const String&);

ALWAYS_INLINE void SharedBuffer::append(const Vector<char>& data)
{
    append(data.data(), data.size());
}

ALWAYS_INLINE bool SharedBuffer::tryAppend(const Vector<char>& data)
{
    return tryAppend(data.data(), data.size());
}

ALWAYS_INLINE SharedBuffer::SharedBuffer()
{
}

ALWAYS_INLINE SharedBuffer::SharedBuffer(size_t size)
: m_buffer(size)
{
}

ALWAYS_INLINE SharedBuffer::SharedBuffer(const char* data, int size)
{
    append(data, size);
}

ALWAYS_INLINE SharedBuffer::SharedBuffer(const unsigned char* data, int size)
{
    append(reinterpret_cast<const char*>(data), size);
}

ALWAYS_INLINE void SharedBuffer::append(SharedBuffer* other)
{
	append(other->m_buffer);
}

ALWAYS_INLINE bool SharedBuffer::tryAppend(SharedBuffer* other)
{
	return tryAppend(other->m_buffer);
}

inline void SharedBuffer::append(const char* data, unsigned length)
{
    if (length)
    	m_buffer.append(data, length);
}

inline bool SharedBuffer::tryAppend(const char* data, unsigned length)
{
    if (!length)
        return true;

	if(m_buffer.tryReserveCapacity(m_buffer.size() + length)){
		m_buffer.append(data, length);
		return true;
	}

	return false;
}

#if !USE(CF) || PLATFORM(QT)

inline void SharedBuffer::clearPlatformData()
{
}

inline bool SharedBuffer::tryReplaceContentsWithPlatformBuffer(SharedBuffer&)
{
	return false;
}

inline void SharedBuffer::maybeTransferPlatformData()
{
}

inline bool SharedBuffer::hasPlatformData() const
{
    return false;
}

inline const char* SharedBuffer::platformData() const
{
    ASSERT_NOT_REACHED();

    return 0;
}

inline unsigned SharedBuffer::platformDataSize() const
{
    ASSERT_NOT_REACHED();

    return 0;
}

#endif

} // namespace WebCore
